com.tibbo.aggregate.common.device.sync

## Class SynchronizationHandler

- java.lang.Object
- - com.tibbo.aggregate.common.device.sync.SynchronizationHandler

-     public abstract class SynchronizationHandler
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SynchronizationHandler()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ValueReader` | `createServerReader()`
    `ValueWriter` | `createServerWriter()`
    `void` | `deinitialize()`
    `VariableStatus` | `getCustomStatus()`
    `protected DeviceContext` | `getDeviceContext()`
    `java.util.Date` | `getDeviceModificationTime()`
    `int` | `getDirectionOverride()`
    `VariableDefinition` | `getPersistentDefinition(VariableDefinition vd)`
    `java.util.Date` | `getServerModificationTime()`
    `SettingSynchronizationOptions` | `getSynchronizationOptions()`
    `protected java.lang.String` | `getVariable()`
    `void` | `initialize(DeviceContext deviceContext, java.lang.String variable, SettingSynchronizationOptions synchronizationOptions, boolean check)`
    `boolean` | `isSynchronizationEnabled()`
    `boolean` | `isUpdatedOnTheServer(CallerController caller)`
    `DataTable` | `readFromCache(CallerController caller, RequestController request)`
    `void` | `setCustomStatus(VariableStatus customStatus)`
    `protected void` | `setSynchronizationEnabled(boolean synchronizationEnabled)`
    `void` | `startSynchronization()`
    `void` | `writeToCache(CallerController caller, RequestController request, DataTable value)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SynchronizationHandler

          public SynchronizationHandler()

  - ### Method Detail

    - #### initialize

          public void initialize(DeviceContext deviceContext,
                                 java.lang.String variable,
                                 SettingSynchronizationOptions synchronizationOptions,
                                 boolean check)
                          throws ContextException

      Throws:
        `ContextException`

    - #### deinitialize

          public void deinitialize()

    - #### startSynchronization

          public void startSynchronization()
                                    throws DeviceException,
                                           ContextException

      Throws:
        `DeviceException`
        `ContextException`

    - #### isSynchronizationEnabled

          public boolean isSynchronizationEnabled()

    - #### setSynchronizationEnabled

          protected void setSynchronizationEnabled(boolean synchronizationEnabled)

    - #### readFromCache

          public DataTable readFromCache(CallerController caller,
                                         RequestController request)
                                  throws ContextException

      Throws:
        `ContextException`

    - #### writeToCache

          public void writeToCache(CallerController caller,
                                   RequestController request,
                                   DataTable value)
                            throws ContextException

      Throws:
        `ContextException`

    - #### createServerWriter

          public ValueWriter createServerWriter()

    - #### createServerReader

          public ValueReader createServerReader()

    - #### getServerModificationTime

          public java.util.Date getServerModificationTime()
                                                   throws ContextException

      Throws:
        `ContextException`

    - #### getDeviceModificationTime

          public java.util.Date getDeviceModificationTime()
                                                   throws ContextException,
                                                          DeviceException,
                                                          DisconnectionException

      Throws:
        `ContextException`
        `DeviceException`
        `DisconnectionException`

    - #### isUpdatedOnTheServer

          public boolean isUpdatedOnTheServer(CallerController caller)
                                       throws ContextException

      Throws:
        `ContextException`

    - #### getDirectionOverride

          public int getDirectionOverride()

    - #### getPersistentDefinition

          public VariableDefinition getPersistentDefinition(VariableDefinition vd)

    - #### getSynchronizationOptions

          public SettingSynchronizationOptions getSynchronizationOptions()

    - #### getDeviceContext

          protected DeviceContext getDeviceContext()

    - #### getVariable

          protected java.lang.String getVariable()

    - #### getCustomStatus

          public VariableStatus getCustomStatus()

    - #### setCustomStatus

          public void setCustomStatus(VariableStatus customStatus)